<?php

namespace app\admin\controller;

use app\admin\common\Ocr;
use app\admin\model\ActionLog;
use app\admin\model\ProcessOrder;
use app\BaseController;
use think\App;
use think\facade\Db;

class Activity extends Base
{
    public $noble=[];
    public function __construct(App $app)
    {
        parent::__construct($app);
        $this->noble=\think\facade\Config::get("noble");
    }
    public function list(){
        $page = isset($this->post['page']) && $this->post['page'] !==""? intval($this->post['page']):"1";
        $size = isset($this->post['size']) && $this->post['size'] !==""? intval($this->post['size']):"10";
        $where = [["ga.is_del","=",0]];
        $activity_name = isset($this->post['activity_name']) && $this->post['activity_name'] !=="" ? trim($this->post['activity_name']):"";
        if($activity_name!=""){
            $where[]=['ga.activity_name',"like","%$activity_name%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where[]=['ga.status',"=",$status];
        }
        $activity_code = isset($this->post['activity_code']) && $this->post['activity_code'] !=="" ? trim($this->post['activity_code']):"";
        if($activity_code!==""){
            $where[]=['ga.activity_code',"like","%$activity_code%"];
        }
        $starttime = isset($this->post['starttime']) && $this->post['starttime']!=="" ? $this->post['starttime']:"";
        if($starttime!==""){
            $where[]=['ga.start',">=",date('Y-m-d H:i:s',strtotime($starttime))];
        }
        $endtime = isset($this->post['endtime']) && $this->post['endtime']!=="" ? $this->post['endtime']:"";
        if($endtime!==""){
            $where[]=['ga.end',"<",date('Y-m-d H:i:s',strtotime($endtime)+24*3600)];
        }
        $platform_code = isset($this->post['platform_code']) && $this->post['platform_code'] !=="" ? trim($this->post['platform_code']):"";
        if($platform_code!==""){
            $where[]=['ga.platform_code',"=",$platform_code];
        }
        $company_id = isset($this->post['company_id']) && $this->post['company_id'] !=="" ? trim($this->post['company_id']):"";
        if($company_id!==""){
            $where[]=['ga.company_id',"=",$company_id];
        }
        $creater = isset($this->post['creater']) && $this->post['creater'] !=="" ? trim($this->post['creater'])
            :"";
        if($creater!=""){
            $where[]=['ga.creater',"like","%$creater%"];
        }
        $createrid = isset($this->post['createrid']) && $this->post['createrid'] !=="" ? trim($this->post['createrid'])
            :"";
        if($createrid!==""){
            $where[]=['ga.createrid',"=",$createrid];
        }
        $role=$this->checkRole();
        if(!empty($role['write'])){
            $where[]=["ga.createrid","in",$role['write']];
        }
        $company_name = isset($this->post['company_name']) && $this->post['company_name'] !== "" ? trim($this->post['company_name']) : "";
        if ($company_name !== "") $where[] = ["ga.createrid", 'in', get_company_item_user_by_name($company_name)];

        $count = Db::name('good_activity')
            ->alias('ga')
            ->where($where)
            ->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('good_activity')
            ->alias('ga')
            ->field('ga.*,p.platform_name,u.itemid')
            ->leftJoin("depart_user u", "u.uid=ga.createrid AND u.is_del=0")
            ->leftJoin("platform p", "p.id=ga.platform_code")
            ->append(['company_name'])
            ->withAttr('company_name',function($val,$data){
                return implode('/', array_column(GetPart($data['itemid']), 'name'));
            })
            ->where($where)
            ->page($page,$size)
            ->order("ga.addtime desc")
            ->select()
            ->toArray();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function linst()
    {
        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [["a.is_del", "=", 0]];
        $skuCode = isset($this->post['skuCode']) && $this->post['skuCode'] !== "" ? trim($this->post['skuCode']) : "";
        if ($skuCode !== "") {
            $where[] = ['a.skuCode', "like", "%$skuCode%"];
        }
        $good_name = isset($this->post['good_name']) && $this->post['good_name'] !== "" ? trim($this->post['good_name']) : "";
        if ($good_name != "") {
            $where[] = ['a.good_name', "like", "%$good_name%"];
        }
        $activity_code = isset($this->post['activity_code']) && $this->post['activity_code'] !=="" ? trim($this->post['activity_code']):"";
        if($activity_code!==""){
            $where[]=['a.activity_code',"like","%$activity_code%"];
        }
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!==""){
            $where[]=['a.status',"=",$status];
        }
        $activity_name = isset($this->post['activity_name']) && $this->post['activity_name'] !=="" ? trim($this->post['activity_name']):"";
        if($activity_name!=""){
            $where[]=['b.activity_name',"like","%$activity_name%"];
        }
        $platform_code = isset($this->post['platform_code']) && $this->post['platform_code'] !=="" ? trim($this->post['platform_code']):"";
        if($platform_code!=""){
            $where[]=['b.platform_code',"=",$platform_code];
        }
        $count = Db::name('activity_info')->alias("a")
            ->join("good_activity b","b.activity_code=a.activity_code","left")
            ->join("platform c","c.id=b.platform_code","left")
            ->where($where)->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('activity_info')->alias("a")
            ->join("good_activity b","b.activity_code=a.activity_code","left")
            ->join("platform c","c.id=b.platform_code","left")
            ->where($where)->page($page,$size)->order("a.addtime desc")->field("a.*,b.activity_name,c.platform_name,c.platform_code
            ")->select();
        return app_show(0,"获取成功",['list'=>$list,'count'=>$count]);
    }
    public function zilist(){
        $page = isset($this->post['page']) && $this->post['page'] !== "" ? intval($this->post['page']) : "1";
        $size = isset($this->post['size']) && $this->post['size'] !== "" ? intval($this->post['size']) : "10";
        $where = [["a.is_del", "=", 0]];
        $spuCode = isset($this->post['spuCode']) && $this->post['spuCode'] !== "" ? trim($this->post['spuCode']) : "";
        if ($spuCode != "") $where[] = ['a.spuCode', "like", "%$spuCode%"];
        $good_name = isset($this->post['good_name']) && $this->post['good_name'] !== "" ? trim($this->post['good_name']) : "";
        if ($good_name != "") $where[] = ['a.good_name', "like", "%$good_name%"];
        $status = isset($this->post['status']) && $this->post['status'] !=="" ? intval($this->post['status']):"";
        if($status!="") $where[]=['a.status',"=",$status];
        $supplierNo = isset($this->post['supplierNo']) && $this->post['supplierNo'] !== "" ? trim($this->post['supplierNo']) : "";
        if ($supplierNo != "") $where[] = ['a.supplierNo', "like", "%$supplierNo%"];
        $name = isset($this->post['name']) && $this->post['name'] !== "" ? trim($this->post['name']) : "";
        if ($name != "") $where[] = ['b.name', "like", "%$name%"];
        $start = isset($this->post['start']) && $this->post['start'] !== "" ? trim($this->post['start']) : "";
        if ($start != "") $where[] = ['a.addtime', ">=", $start];
        $end = isset($this->post['end']) && $this->post['end'] !== "" ? trim($this->post['end']) : "";
        if ($end != "") $where[] = ['a.addtime', "<=", $end.' 23:59:59'];

        $count = Db::name('good_zixun')
            ->alias("a")
            ->join("supplier b","b.code=a.supplierNo","left")
            ->where($where)
            ->count();
        $total = ceil($count / $size);
        $page = $page >= $total ? $total : $page;
        $list = Db::name('good_zixun')
            ->alias("a")
            ->join("supplier b","b.code=a.supplierNo","left")
            ->where($where)
            ->page($page,$size)
            ->order("a.addtime desc")
            ->field("a.*,b.name")
            ->select()
            ->toArray();
//halt($list);
        $data=[];
        //分类/规格/品牌 等字段取出对应文字
        foreach ($list as $value){
            $value['cat_info']= made($value['cat_id'],[]);
            $platform = Db::name("platform")->where(["id"=>$value['platform_id']])->find();
            $value['platform_name'] = isset($platform['platform_name']) ? $platform['platform_name']:"";
            $value['platform_code_en'] = isset($platform['platform_code_en']) ? $platform['platform_code_en']:"";
            $supplier = Db::name("supplier")->where(["code"=>$value['supplierNo']])->find();
            $value['supplier_name'] = isset($supplier['name']) ? $supplier['name']:"";
            $brand=Db::name("brand")->where(["id"=>$value['brand_id']])->find();
            $value["brand_name"]=isset($brand['brand_name'])?$brand['brand_name']:"";
            $unit = Db::name("unit")->where(["id"=>$value['good_unit']])->find();
            $value['unit'] =isset($unit['unit'])?$unit['unit']:"";
            $company = Db::name("business")->where(["companyNo"=>$value['companyNo']])->find();
            $value['company'] = isset($company['company'])?$company['company']:"";
//            $company = Db::name("business")->where(["companyNo"=>$value['companyNo']])->find();
//            $value['company'] = isset($company['company'])?$company['company']:"";
            $value['stock_total'] = Db::name("good_stock")->where(['spuCode'=>$value['spuCode'],"is_del"=>0])->sum("usable_stock");
//            $value['status']=$value['exam_status'];
//            $value['exclusive']=makeExcluse($value['is_exclusive']);
            $value['good_info_img']=$value['good_info_img'];
            $value['good_img']=$value['good_img'];
            $spec = Db::name("good_spec")->where(["spuCode"=>$value['spuCode'],"is_del"=>0])->select()->toArray();
            $speclist=[];
            if(!empty($spec)){
                foreach ($spec as $val){
                    $temp=[];
                    $temp['spec_id']=$val['spec_id'];
                    $temp['spec_value_id']=$val['spec_value_id'];
                    $sp = Db::name("specs")->where(["id"=>$val['spec_id']])->find();
                    $temp['spec_name']=isset($sp["spec_name"]) ? $sp["spec_name"]:"";
                    $spv = Db::name("spec_value")->where(["id"=>$val['spec_value_id']])->find();
                    $temp['spec_value']=isset($spv["spec_value"]) ? $spv["spec_value"]:"";
                    $speclist[]=$temp;
                }
            }
            $value['specinfo']=$speclist;
            $value['noble_name']=isset($value['noble_metal'])&&$value['noble_metal']!=0?$this->noble[$value['noble_metal']] :"";
            $data[]=$value;
        }

        return app_show(0,"获取成功",['list'=>$data,'count'=>$count]);
    }

    //创建活动
    public function create(){
        $activity_name = isset($this->post['activity_name'])&&$this->post['activity_name']!="" ? trim($this->post['activity_name']):"";
        if($activity_name==""){
            return error_show(1004,"参数activity_name不能为空");
        }
        $platform_code = isset($this->post['platform_code'])&&$this->post['platform_code']!="" ? trim($this->post['platform_code']):"";
        if($platform_code==""){
            return error_show(1004,"参数platform_code不能为空");
        }
        $company_id = isset($this->post['company_id'])&&$this->post['company_id']!="" ? trim($this->post['company_id']):"";
        if($company_id==""){
            return error_show(1004,"参数company_id不能为空");
        }
        $activity_start = isset($this->post['activity_start'])&&$this->post['activity_start']!="" ? $this->post['activity_start']:"";
        if($activity_start==""){
            return error_show(1004,"参数activity_start不能为空");
        }
        $activity_end = isset($this->post['activity_end'])&&$this->post['activity_end']!="" ? $this->post['activity_end']:"";
        if($activity_end==""){
            return error_show(1004,"参数activity_end不能为空");
        }
        $activity_desc = isset($this->post['activity_desc'])&&$this->post['activity_desc']!="" ?
            trim($this->post['activity_desc']):"";
        if($activity_desc==""){
            return error_show(1004,"参数activity_desc不能为空");
        }
        $is_stock = isset($this->post['is_stock'])&&$this->post['is_stock']!=="" ?
            intval($this->post['is_stock']):"";
        if($is_stock===""){
            return error_show(1004,"参数is_stock不能为空");
        }
        $good_list= isset($this->post['good_list'])&&$this->post['good_list']!=="" ?$this->post['good_list']:"";
        if($good_list==""){
            return error_show(1004,"参数good_list不能为空");
        }
        $token = isset($this->post['token'])&& $this->post['token']!='' ? trim($this->post['token']):"";
        if($token==''){
            return error_show(105,"参数token不能为空");
        }
        $user =GetUserInfo($token);
        if(empty($user)||$user['code']!=0){
            return error_show(102,"用户数据不存在");
        }
        $createrid= isset($user["data"]['id']) ?  $user["data"]['id'] : "";
        $creater= isset($user["data"]['nickname']) ?  $user["data"]['nickname'] : "";
        $activity_code = makeNo("AT");
        Db::startTrans();
        try{
            $data=[
                "activity_name"=>$activity_name,
                "activity_code"=>$activity_code,
                "is_stock"=>$is_stock,
                "start"=>$activity_start,
                "end"=>$activity_end,
                "platform_code"=>$platform_code,
                "activity_desc"=>$activity_desc,
                "company_id"=>$company_id,
                "creater"=>$creater,
                "createrid"=>$createrid,
                "status"=>1,
                "is_del"=>0,
                "addtime"=>date("Y-m-d H:i:s"),
                "updatetime"=>date("Y-m-d H:i:s")
            ];
            $inset = Db::name("good_activity")->insertGetId($data);
            if($inset>0){
                if($good_list!=""&&!empty($good_list)){
                    $temp=[];
                    foreach ($good_list as $value){
                        $lemp=[];
                        $good = Db::name('good')->alias("a")->leftJoin("good_platform b","a.spuCode=b.spuCode")
                            ->where(["skuCode"=>$value['skuCode'],"a.is_del"=>0])->find();
                        $lemp['skuCode']=$value['skuCode'];
                        $lemp['good_name']=isset($good['good_name']) ?$good['good_name']:"" ;
                        $lemp['activity_code']=$activity_code;
                        $lemp['activity_stock']=$value['activity_stock'];
                        $lemp['moq_num']=0;
                        $lemp['cost_price']=0;
                        $lemp['sale_price']=0;
                        $lemp['activity_price']=0;
                        $lemp['status']=0;
                        $lemp['remark']="";
                        $lemp['is_del']=0;
                        $lemp['addtime']=date("Y-m-d H:i:s");
                        $lemp['updatetime']=date("Y-m-d H:i:s");
                        $temp[]=$lemp;

                        //当是库存品的时候校验可用库存数，不满足的时候不能添加
                        if ($is_stock == 1) {
                            $usable_stock = Db::name('good_stock')
                                ->where(['spuCode' => $good['spuCode'], 'is_del' => 0])
                                ->sum('usable_stock');

                            if ($value['activity_stock'] > $usable_stock) {
                                Db::rollback();
//                                throw new \Exception($lemp['good_name'] . '的库存只有' . $usable_stock);
                                return app_show(1005,'库存不足',[$lemp['good_name']. '的库存只有' . $usable_stock]);
                            }
                        }

                    }
                    $iall=Db::name("activity_info")->insertAll($temp);
                    if($iall==0){
                        Db::rollback();
                        return error_show(1005,"新建失败");
                    }
                }

                $stn = ["order_code" => $activity_code, "status" => 0, "action_remark" => '', "action_type" => "create"];
                ActionLog::logAdd($this->post['token'], $stn, "HD", $data['status'], $data);
                $process = ["order_code" => $activity_code, "order_id" => $inset, "order_status" => $data['status'], "order_type" => 'HD', "before_status" => 0];
                ProcessOrder::AddProcess($this->post['token'], $process);

                Db::commit();
                return app_show(0,"新建成功");
            }

        }catch (\Exception $e){
            Db::rollback();
            return error_show(1005,$e->getMessage());
        }
    }

    //采购定价
    public  function  cost(){
        $good_list= isset($this->post['good_list'])&&!empty($this->post['good_list']) ?$this->post['good_list']:"";
        if($good_list==""){
            return error_show(1004,"参数good_list不能为空");
        }
        $activity_code= isset($this->post['activity_code'])&&$this->post['activity_code']!=="" ?trim($this->post['activity_code']):"";
        if($activity_code==""){
            return error_show(1004,"参数activity_code不能为空");
        }
        $activity = Db::name("good_activity")->where(["activity_code"=>$activity_code,"is_del"=>0])->find();
        if($activity==false){
            return error_show(1004,"未找到活动数据");
        }
        Db::startTrans();
        try{
            foreach ($good_list as $value){
                $temp=[];
                $ladd = Db::name("good_ladder")->where(["skuCode"=>$value['skuCode'],"is_del"=>0])->where
                ([["min_num","<=",$value['moq_num']]])->order("min_num desc")->find();
                $temp["id"]=$value['id'];
                $temp["cost_price"]=$value['cost_price'];
                $temp["moq_num"]=$value['moq_num'];
                $temp["sale_price"]=isset($ladd['sale_price'])?$ladd['sale_price']:0;
                $temp["updatetime"]=date("Y-m-d H:i:s");
                $up=Db::name("activity_info")->save($temp);
                if($up==false){
                    Db::rollback();
                    return error_show(1004,"商品数据更新失败");
                }
            }
            $old_activity_status = $activity['status'];
            $activity['status']=2;
            $activity['updatetime']=date("Y-m-d H:i:s");
            $act = Db::name("good_activity")->save($activity);
            if($act){

                $stn = ["order_code" => $activity_code, "status" => $old_activity_status, "action_remark" => '', "action_type" => "status"];
                ActionLog::logAdd($this->post['token'], $stn, "HD", $activity['status'], $activity);
                $process = ["order_code" => $activity_code, "order_id" => $activity['id'], "order_status" => $activity['status'], "order_type" => 'HD', "before_status" => $old_activity_status];
                ProcessOrder::AddProcess($this->post['token'], $process);

                Db::commit();
                return error_show(0,"商品数据更新成功");
            }else{
                Db::rollback();
                return error_show(1004,"商品数据更新失败");
            }

        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    //财务定价
    public  function  activity(){
        $good_list= isset($this->post['good_list'])&&!empty($this->post['good_list']) ?$this->post['good_list']:"";
        if($good_list==""){
            return error_show(1004,"参数good_list不能为空");
        }
        $activity_code= isset($this->post['activity_code'])&&$this->post['activity_code']!=="" ?trim($this->post['activity_code']):"";
        if($activity_code==""){
            return error_show(1004,"参数activity_code不能为空");
        }
        $activity = Db::name("good_activity")->where(["activity_code"=>$activity_code,"is_del"=>0])->find();
        if($activity==false){
            return error_show(1004,"未找到活动数据");
        }
        Db::startTrans();
        try{
            foreach ($good_list as $value){
                $temp=[];
                $temp["id"]=$value['id'];
                $temp["activity_price"]=$value['activity_price'];
                $temp["updatetime"]=date("Y-m-d H:i:s");
                $up=Db::name("activity_info")->save($temp);
                if($up==false){
                    Db::rollback();
                    return error_show(1004,"商品数据更新失败");
                }
            }
            $old_activity_status = $activity['status'];
            $activity['status']=3;
            $activity['updatetime']=date("Y-m-d H:i:s");
            $act = Db::name("good_activity")->save($activity);
            if($act){

                $stn = ["order_code" => $activity_code, "status" => $old_activity_status, "action_remark" => '', "action_type" => "status"];
                ActionLog::logAdd($this->post['token'], $stn, "HD", $activity['status'], $activity);
                $process = ["order_code" => $activity_code, "order_id" => $activity['id'], "order_status" => $activity['status'], "order_type" => 'HD', "before_status" => $old_activity_status];
                ProcessOrder::AddProcess($this->post['token'], $process);

                Db::commit();
                return error_show(0,"商品数据更新成功");
            }else{
                Db::rollback();
                return error_show(1004,"商品数据更新失败");
            }

        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    //财务审核定价
    public  function  exam(){
        $good_list= isset($this->post['good_list'])&&!empty($this->post['good_list']) ?$this->post['good_list']:"";
        if($good_list==""){
            return error_show(1004,"参数good_list不能为空");
        }
        $activity_code= isset($this->post['activity_code'])&&$this->post['activity_code']!=="" ?trim($this->post['activity_code']):"";
        if($activity_code==""){
            return error_show(1004,"参数activity_code不能为空");
        }
        $activity = Db::name("good_activity")->where(["activity_code"=>$activity_code,"is_del"=>0])->find();
        if($activity==false){
            return error_show(1004,"未找到活动数据");
        }
        Db::startTrans();
        try{
            foreach ($good_list as $value){
                $temp=[];
                $temp["id"]=$value['id'];
                $temp["status"]=$value['status'];
                $temp["remark"]=$value['remark'];
                $temp["updatetime"]=date("Y-m-d H:i:s");
                $up=Db::name("activity_info")->save($temp);
                if($up==false){
                    Db::rollback();
                    return error_show(1004,"商品数据更新失败");
                }
            }
            $old_activity_status = $activity['status'];
            $activity['status']=4;
            $activity['updatetime']=date("Y-m-d H:i:s");
            $act = Db::name("good_activity")->save($activity);
            if($act){

                $stn = ["order_code" => $activity_code, "status" => $old_activity_status, "action_remark" => '', "action_type" => "status"];
                ActionLog::logAdd($this->post['token'], $stn, "HD", $activity['status'], $activity);
                $process = ["order_code" => $activity_code, "order_id" => $activity['id'], "order_status" => $activity['status'], "order_type" => 'HD', "before_status" => $old_activity_status];
                ProcessOrder::AddProcess($this->post['token'], $process);

                Db::commit();
                return error_show(0,"商品数据审核成功");
            }else{
                Db::rollback();
                return error_show(1004,"商品数据审核失败");
            }

        }catch (\Exception $e){
            Db::rollback();
            return error_show(1004,$e->getMessage());
        }
    }

    //活动详情
    public function info()
    {
        $activity_code = isset($this->post['activity_code']) && $this->post['activity_code'] !== "" ? trim($this->post['activity_code']) : "";
        if ($activity_code == "") {
            return error_show(1004, "参数activity_code不能为空");
        }
        $activity = Db::name("good_activity")
            ->alias('ga')
            ->field('ga.*,p.platform_name')
            ->leftJoin('platform p', 'p.id=ga.platform_code AND p.is_del=0')
            ->where(["ga.activity_code" => $activity_code, "ga.is_del" => 0])
            ->find();
        if ($activity == false) {
            return error_show(1004, "未找到活动数据");
        }
        $activity_info = Db::name("activity_info")
            ->where(["activity_code" => $activity_code, "is_del" => 0])
            ->select()
            ->toArray();
        $activity['info'] = empty($activity_info) ? [] : $activity_info;
        return app_show(0, "获取成功", $activity);
    }

    //修改活动状态
    public function  actstatus(){
        $activity_code= isset($this->post['activity_code'])&&$this->post['activity_code']!=="" ?trim($this->post['activity_code']):"";
        if($activity_code==""){
            return error_show(1004,"参数activity_code不能为空");
        }
        $activity = Db::name("good_activity")->where(["activity_code"=>$activity_code,"is_del"=>0])->find();
        if($activity==false){
            return error_show(1004,"未找到活动数据");
        }
        $status =  isset($this->post['status'])&&$this->post['status']!=="" ?intval($this->post['status']):"";
        if($status==""){
            return error_show(1004,"参数status不能为空");
        }
        $remark =isset($tihs->post['remark'])&&$this->post['remark']!="" ? trim($this->post['remark']):"";
        if($remark=="" &&$status==8){
            return error_show(1004,"参数remark不能为空");
        }
        $old_status = $activity['status'];
        $activity['status']=$status;
        $activity['remark']=$remark;
        $activity['updatetime']=date("Y-m-d H:i:s");
        $up = Db::name("good_activity")->save($activity);
        if($up){

            $stn = ["order_code" => $activity_code, "status" => $old_status, "action_remark" => '', "action_type" => "status"];
            ActionLog::logAdd($this->post['token'], $stn, "HD", $activity['status'], $activity);
            $process = ["order_code" => $activity_code, "order_id" => $activity['id'], "order_status" => $activity['status'], "order_type" => 'HD', "before_status" => $old_status];
            ProcessOrder::AddProcess($this->post['token'], $process);

            return  app_show(0,"修改成功");
        }else{
            return  error_show(1004,"修改失败");
        }

    }

    public function query(){
      $skuCode= isset($this->post['skuCode'])&&$this->post['skuCode']!=""?trim($this->post['skuCode']):"";
      if($skuCode==""){
          return error_show(1004,"参数skuCode不能为空");
      }
      $where=['a.is_del'=>0,"b.is_del"=>0,"a.status"=>6,"b.status"=>1,"b.skuCode"=>$skuCode];
      $condition=['a.skuCode' =>$skuCode,"a.is_del"=>0,'a.exam_status'=>6];
      $company =  isset($this->post['companyNo'])&&$this->post['companyNo']!=""?trim($this->post['companyNo']):"";
      if($company!=""){
          $where['a.company_id'] = $company;
          $condition['companyNo'] = $company;

      }
        $plat =isset($this->post['platform_id'])&&$this->post['platform_id']!=""?intval($this->post['platform_id'])
            :"";
      if($plat!==""){
          $where['a.platform_code'] = $plat;
          $condition['platform_code'] = $plat;
      }
        $good =  Db::name('good_platform')->alias('a')->join('good b', 'b.spuCode=a.spuCode', 'left')
            ->where($condition)->select()->toArray();
      $goodlist=[];
        if(!empty($good)){
            foreach ($good as $value){
                $temp=[];
                $stock =Db::name("good_stock")->where(["spuCode"=>$value['spuCode'],"is_del"=>0])->sum('usable_stock');

                //如果是非库存商品，库存数改为最大(即将库存设为无限)
                $temp['stock_num'] = $value['is_stock'] == 1 ? intval($stock) : 9999;

                $temp['skuCode']=$value['skuCode'];
                $temp['spuCode']=$value['spuCode'];
                $temp['is_stock']=$value['is_stock'];
                $temp['good_name']=$value['good_name'];
                $temp['good_img']=$value['good_img'];
                $temp['good_info_img']=$value['good_info_img'];
                $temp['noble_metal']=$value['noble_metal'];
                $temp['noble_name']=$value['noble_metal']!=0?$this->noble[$value['noble_metal']]:"";
                $goodlist[]=$temp;
            }
        }
      $list =  Db::name('good_activity')->alias("a")
            ->join("activity_info b","b.activity_code=a.activity_code","left")
            ->where($where)->field('b.id,a.activity_name,a.activity_code,a.is_stock,a.start,a.end,b.skuCode,b.good_name,b.activity_stock,
            b.cost_price,b.moq_num,b.sale_price,b.activity_price')->select()->toArray();
      return app_show(0,"获取成功",["act"=>$list,"good"=>$goodlist]);
    }


}